#ifndef EFL_UI_ITEM_EO_HH
#define EFL_UI_ITEM_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_item.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace ui { 
struct Item;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Item> : ::std::true_type {}; } }
namespace efl { namespace ui { 
struct Item;
} } 

namespace eo_cxx {
namespace efl { namespace ui { 
struct Item {
   ::efl::eolian::return_traits< ::efl::ui::Item>::type prev_get() const;
   ::efl::eolian::return_traits< ::efl::ui::Item>::type next_get() const;
   ::efl::eolian::return_traits<bool>::type selected_get() const;
   ::efl::eolian::return_traits<void>::type selected_set( ::efl::eolian::in_traits<bool>::type selected) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_ITEM_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::Item() const;
   operator ::efl::ui::Item&();
   operator ::efl::ui::Item const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Item : ::efl::eo::concrete
{
   explicit Item( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Item(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Item(Item const& other) = default;
   Item(Item&& other) = default;
   Item& operator=(Item const& other) = default;
   Item& operator=(Item&& other) = default;
   Item()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Item( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Item(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::ui::Item>::type prev_get() const;
   ::efl::eolian::return_traits< ::efl::ui::Item>::type next_get() const;
   ::efl::eolian::return_traits<bool>::type selected_get() const;
   ::efl::eolian::return_traits<void>::type selected_set( ::efl::eolian::in_traits<bool>::type selected) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_ITEM_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Item> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Item const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Item) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Item>::value, "");
} } 
#endif
